package com.openexchange.office.tools.common.osgi.context.test;

import java.util.Collection;
import java.util.Collections;

import com.openexchange.config.ConfigurationService;

public abstract class UnittestInformation {

	protected ConfigurationService configurationService;
	protected TestOsgiBundleContextAndUnitTestActivator testOsgiBundleContextAndUnitTestActivator;
	
	protected abstract Collection<Class<?>> getClassesToMock();
	
	protected void setTestOsgiBundleContextAndUnitTestActivator(TestOsgiBundleContextAndUnitTestActivator testOsgiBundleContextAndUnitTestActivator) {
		this.testOsgiBundleContextAndUnitTestActivator = testOsgiBundleContextAndUnitTestActivator;
	}

	public ConfigurationService initConfigService() {
		if (configurationService == null) {
			configurationService = testOsgiBundleContextAndUnitTestActivator.getMock(ConfigurationService.class);
		}
		return configurationService;
	}
			
	protected void initMocks() {}
	
	protected Collection<Class<?>> getClassesToInstantiateForUnitttest() {
		return Collections.emptySet();
	}
	
	protected Collection<Object> getAdditionalServices() {
		return Collections.emptySet();
	}
}
